double deter(struct matrix M)
{
	int D=M.D;
	double det;
	gsl_matrix *LU;
	gsl_permutation *perm;
	int i, j;
	int  signum;

	LU = gsl_matrix_alloc (D, D);
	perm = gsl_permutation_alloc (D);

	for (i = 0; i < D; i++)
		for (j = 0; j < D; j++)
		gsl_matrix_set (LU, i, j, M.m[i][j]);

	// LU decomposition
	gsl_linalg_LU_decomp ( LU, perm, &signum);


	// Determinant
	det = gsl_linalg_LU_det(LU, signum);

	gsl_matrix_free (LU);
	gsl_permutation_free (perm);

	return det;
}